
#
#           Y. Okamoto, 2017.11
#

class Node:
    def __init__(self):
        self.v = 0
        self.s = 0
        self.e = 0

class NonMetricAve:
    """
            The up-and-down-blocks algorithm
        I. Borg & P. J. F. Groenen(2005). Modern multidimensional scaling, 2nd ed., (p. 206).
        J. B. Kruskal (1964). Nonmetric multidimensional scaling.
                                  Psychometrika, 115-129 (pp. 126-128).
                                            
    """
    def __init__(self, dist):
        self.Dist = []
        self.M = len(dist)
        for i in range(self.M):
            self.Dist.append(Node())
            self.Dist[i].v = dist[i]
            self.Dist[i].s = i
            self.Dist[i].e = i

    def DoAve(self):
        pos = 0
        act = -1
        while True:
            #print('pos = ', pos)
            if (act == -1):
                act = 1
                if (self.Dist[pos].e >= self.M - 1):
                    break
                if (self.Dist[pos].v > self.Dist[self.Dist[pos].e + 1].v):
                    act = 2
                    while True:
                        tv = self.Dist[pos].v * (self.Dist[pos].e - self.Dist[pos].s + 1) + \
                                self.Dist[self.Dist[pos].e + 1].v * \
                                (self.Dist[self.Dist[pos].e + 1].e - \
                                 self.Dist[self.Dist[pos].e + 1].s + 1)
                        tv /= self.Dist[self.Dist[pos].e + 1].e - self.Dist[pos].s + 1
                        self.Dist[pos].v = tv
                        self.Dist[pos].e = self.Dist[self.Dist[pos].e + 1].e
                        self.Dist[self.Dist[pos].e].v = tv
                        self.Dist[self.Dist[pos].e].s = self.Dist[pos].s
                        #print('Up/  pos = {0}   v = {1}   s = {2}  e = {3}'.\
                        #      format(pos, tv, self.Dist[pos].s, self.Dist[pos].e))
                        if (self.Dist[pos].e >= self.M - 1):
                            break
                        if (self.Dist[pos].v <= self.Dist[self.Dist[pos].e + 1].v):
                                break
                else:
                    pos = self.Dist[pos].e + 1
                    act = -1
                    if (pos >= self.M - 1):
                        break
                        
                    
                # act = -1
            if (act == 2):
                if self.Dist[pos].s > 0:
                    if (self.Dist[pos].v < self.Dist[self.Dist[pos].s - 1].v):  # A
                        while True:
                            act = -1
                            tv = self.Dist[pos].v * (self.Dist[pos].e - self.Dist[pos].s + 1) + \
                                    self.Dist[self.Dist[pos].s - 1].v * \
                                    (self.Dist[self.Dist[pos].s - 1].e - \
                                     self.Dist[self.Dist[pos].s - 1].s + 1)
                            tv /= self.Dist[pos].e - self.Dist[self.Dist[pos].s - 1].s + 1
                            e = self.Dist[pos].e
                            pos = self.Dist[self.Dist[pos].s - 1].s
                            self.Dist[pos].s = pos
                            self.Dist[pos].v = tv
                            self.Dist[pos].e = e
                            self.Dist[e].v = tv
                            self.Dist[e].s = self.Dist[pos].s
                            self.Dist[e].e = e
                            #print('Dwn/ pos = {0}   v = {1}   s = {2}  e = {3}'.\
                            #      format(pos, tv, self.Dist[pos].s, self.Dist[pos].e))
                            if (self.Dist[pos].s <= 0):
                                break
                            if (self.Dist[pos].v >= self.Dist[self.Dist[pos].s - 1].v):
                                break
                    else:   # A
                        pos = self.Dist[pos].e + 1
                        act = -1
                        # break
                else:
                    pos = self.Dist[pos].e + 1
                    act = -1
           
            if (pos >= self.M - 1):
                break

        spos = 0
        while True:
            cks = self.Dist[spos].s
            cke = self.Dist[spos].e
            if (cke > cks + 1):
                for i in range(cke - cks - 1):
                    self.Dist[spos + i + 1].v = self.Dist[spos].v
            spos = cke + 1
            if (spos >= self.M - 1):
                break
            

